/* RIFF file utilities */

.version "$Id: riff.s,v 1.4 2001/11/25 14:58:45 bernd Exp $"


.text

/*  Get address and length of specified chunk
 * in  : chunkID=%eax buff=%esi
 * out : start=%esi count=%ecx
 */
.align 4
chunk:	cmpl (%esi),%eax
	je 1f

2:	movl 4(%esi),%ecx	# count
	leal 8(%esi,%ecx),%esi	# start address
	cmpl (%esi),%eax
	jne 2b			# chunkID not found
	
1:	movl 4(%esi),%ecx	# return chunk's count
	leal 8(%esi),%esi	# and start address
	ret


/*  Get address and length of `data' chunk
 * out : start=esi count=%ecx
 */
.align 4
.global datachunk
datachunk:
	movl $0x61746164,%eax	# 'data'
0:	leal wavbuf+3*4,%esi	# skip over `RIFF',length,`WAVE'
	call chunk
	ret


/*  Get address and length of `fmt' chunk
 * out : start=esi count=%ecx
 */
.align 4
.global fmtchunk
fmtchunk:
	movl $0x20746d66,%eax	# `fmt '
	jmp 0b
.end
