/* Linux system calls
 *   man syscalls
 *   /usr/include/asm/unistd.h
 */

.version "$Id: syscall.s,v 1.2 2001/11/23 15:58:18 bernd Exp $"


.macro syscall n
	movl \n,%eax
	int $0x80
.endm


.text
	# void _exit(int status);
.align 4
.global exit
exit:	syscall $1

	# ssize_t read(int fd, void *buf, size_t count);
.align 4
.global read
read:	syscall $3
	ret

	# ssize_t write(int fd, const void *buf, size_t count);
.align 4
.global write
write:	syscall $4
	ret
	
	# int open(const char *pathname, int flags, mode_t mode);
.align 4
.global open
open:	syscall $5
	ret

	# int close(int fd);
.align 4
.global close
close:	syscall $6
	ret

	# int ioctl(int d, int request, char *argp)
.align 4
.global ioctl
ioctl:	syscall $54
	ret
.end
